package 
{
	import appkit.responders.NResponder;
	import com.greensock.plugins.TintPlugin;
	import com.greensock.plugins.TweenPlugin;
	import com.greensock.TweenMax;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.DropShadowFilter;
	import org.flashdevelop.utils.FlashConnect;
	
	
	/**
	 * ...
	 * @author Iargo A Rocha
	 */
	public class Cor extends MovieClip {
		private var tela:mcCor = new mcCor();
		private var _cor:int;
		private var _nome:String;
		private var _combinacoes:Vector.<CorSecundaria>;
		
		public function Cor(p_cor:int, p_combinacoes:Vector.<CorSecundaria>, p_nome:String = "Cor sem nome"):void {
			_combinacoes = p_combinacoes;
			this._nome = _nome;
			TweenPlugin.activate([TintPlugin]);
			_nome = p_nome;
			_cor = p_cor;
			tela.buttonMode = true;
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			FlashConnect.trace("Cor init()");
			removeEventListener(Event.ADDED_TO_STAGE, init);
			TweenMax.to(tela.cor_mc, .5, { tint:_cor } );
			tela.cor_mc.filters = [];
			tela.addEventListener(MouseEvent.CLICK, trocaCor);
			tela.addEventListener(MouseEvent.ROLL_OVER, function():void {
				NResponder.dispatch('aparece_legenda', [nome]);
			})
			tela.addEventListener(MouseEvent.ROLL_OUT, function():void {
				NResponder.dispatch('desaparece_legenda');
			})
			addChild(tela);
		}
		
		private function trocaCor(e:MouseEvent):void {
			NResponder.dispatch('cor_selecionada', [_cor]);
		}
		
		public function get nome():String {
			return _nome;
		}
		
		public function get combinacoes():Vector.<CorSecundaria> 
		{
			return _combinacoes;
		}
		
		public function get cor():int 
		{
			return _cor;
		}
		public function seleciona():void {
			var innerShadow:DropShadowFilter = new DropShadowFilter();
			
			innerShadow.distance = 2;
			innerShadow.strength = .4;
			innerShadow.inner = true;
			innerShadow.angle = -30;
			var filtros:Array = [innerShadow];
			tela.filters = filtros;
			tela.gotoAndStop(2);
			TweenMax.to(tela, 1, { alpha:1, blurFilter:{blurX:0, blurY:0}} );
		}
		public function deseleciona():void {
			tela.gotoAndStop(1);
			TweenMax.to(tela, .5, { alpha:.4, blurFilter:{blurX:5, blurY:5} } );
		}
		
	}
}