package 
{
	import appkit.responders.NResponder;
	import com.greensock.TweenMax;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.utils.setTimeout;
	import org.flashdevelop.utils.FlashConnect;
	
	/**
	 * ...
	 * @author Iargo A Rocha
	 */
	public class Passador {
		private var passador:MovieClip;
		private var cores:Array;
		private var selecionada:int = 0;
		private var ordem:int = 1;
		private var tamanho_gota:Number = 35;
		private var _cor:int;
		private var _nome:String;
		
		public function Passador (passador:MovieClip, cores:Array, ordem:int = 1):void {
			FlashConnect.trace("Passador");
			this.cores = cores;
			this.passador = passador;
			this.ordem = ordem;
			
			for (var i:int = 0; i < cores.length; i++) {
				cores[i].x = i * tamanho_gota;
				passador.cores_mc.addChild(cores[i]);
			}
			
			passador.passadores_mc.esquerda_mc.buttonMode = passador.passadores_mc.direita_mc.buttonMode = true;
			
			passador.passadores_mc.esquerda_mc.addEventListener(MouseEvent.CLICK, andaEsquerda);
			passador.passadores_mc.direita_mc.addEventListener(MouseEvent.CLICK, andaDireita);
			anda();
		}
		
		private function andaDireita(e:MouseEvent):void {
			selecionada--;
			anda();
		}
		
		private function andaEsquerda(e:MouseEvent):void {
			selecionada++;
			anda();
		}
		
		public function anda():void {
			for (var i:int = 0; i < cores.length; i++) {
				if(selecionada*-1!=i){
					cores[i].deseleciona();
				} else {
					cores[i].seleciona();
					passador.nome_txt.text = cores[selecionada * -1].nome;
					nome = cores[selecionada * -1].nome;
					cor = cores[selecionada * -1].cor;
					trace("------\n trocou para " + nome );
					Main['cor'+ordem] = nome;
				}
			}
			TweenMax.killTweensOf(passador.cores_mc);
			TweenMax.to(passador.cores_mc, .5, { x:selecionada * tamanho_gota + tamanho_gota, blurX:20 } );
			
			if (selecionada == 0) {
				passador.passadores_mc.esquerda_mc.visible = false;
			} else {
				passador.passadores_mc.esquerda_mc.visible = true;
			} 
			
			if (selecionada * -1 == cores.length-1 || cores.length == 1) {
				passador.passadores_mc.direita_mc.visible = false;
			} else {
				passador.passadores_mc.direita_mc.visible = true;
			} 
			if ('[object Cor]' == cores[0]) { 
				mostra_secundarias();
			}
			
		}
		private function mostra_secundarias():void {
			NResponder.dispatch('cores_secundarias', [cores[selecionada*-1].combinacoes]);
		}
		public function renova(cores:Array):void {
			var n:int = passador.cores_mc.numChildren;
			for (var i:int = 0; i < n; i++) {
				passador.cores_mc.removeChildAt(0);	
			}
			
			this.cores = cores;
			
			for (var j:int = 0; j < cores.length; j++) {
				cores[j].x = j * tamanho_gota;
				passador.cores_mc.addChild(cores[j]);
			}
			selecionada = 0;
			anda();
		}
		
		
		public function get cor():int 
		{
			return _cor;
		}
		public function set cor(value:int):void 
		{
			_cor = value;
		}
		
		public function get nome():String 
		{
			return _nome;
		}
		
		public function set nome(value:String):void 
		{
			_nome = value;
		}
	}	
}