﻿/**
 * NIdentifier class
 * 
 * @version NIdentifier v1.0
 * @author Diney Bomfim
 */
package com.appkit.utils 
{
	import flash.utils.Dictionary;
	/**
	 * 
	 * @langversion ActionScript 3.0
	 * @playerversion Flash 9.0
	 */
	public final class NIdentifier
	{
		
	//**************************************************
	//  Protected / Private Properties
	//**************************************************
		
		/**
		 * The count to the IDs.
		 */
		private static var $index:uint = 0;
		
		/**
		 * The reference to identify the objects.
		 */
		private static var $references:Dictionary = new Dictionary(true);
		
	//**********************************************************************************************************
	//
	//  Public Methods
	//
	//**********************************************************************************************************
		
		/**
		 * Create and return an Unique Identifier (ID) to an Object.
		 * 
		 * @param	object		An object create an identifier.
		 * 
		 * @return				The identifier.
		 * 
		 * @langversion ActionScript 3.0
		 * @playerversion Flash 9.0
		 */
		public static function from(object:*):uint
        {
			if (!(object in $references))
			{
				$references[object] = ++$index;
			}
			
			return $references[object];
        }
	}
}