package com.utils

{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import com.greensock.TweenLite;
	import flash.geom.Rectangle;
	import flash.utils.setInterval;
	import flash.utils.clearInterval;
	
	/**
	 * 
	 * @author Iargo
	 * 
	 * 
	 */
	public class ScrollHorizontalFB extends MovieClip
	{
		private var scroll:mcScrollHorizontal;
		private var _mascara:Sprite;
		private var _container:Sprite;
		private var _movimento:Number;
		private var _redimensionamento:Boolean;
		private var _delay:Number;
		
		private var limiteArraste:Rectangle;
		
		private var pontoMaximo:Number;
		private var pontoMinimo:Number;
		
		private var destinoContainer:Number;
		private var destinoCarrinho:Number;
		
		private var intervaloBotoes:uint;
		
				/**
		 * O Construtor da classe ScrollHorizontalFB.
		 * 
		 * <p/>
		 * 
		 * Cria um scroll vertical ao lado do movie clip mascara
		 * 
		 * <p/>
		 * 
		 * 
		 * 
		 * @param	mascara					Identifica o Sprite usado como mascara para a exibição da imagem
		 * 						
		 * @param	container				Identifica o Sprite onde está o conteudo a ser exibido somente no espaço determinado pela máscara
		 * 
		 * @param	movimento				Espaço que o container vai se movimentar a cada clique nos botões cima_mc e baixo_mc
		 * 
		 * @param	redimensionamento		Redimensiona ou não o carrinho_mc (MovieClip arrastável) de acordo com a proporção mascara/container
		 *  
		 * @param	delay					Tempo para que o container chegue ao local de destino após um clique ou após o usuário arrastar o carrinho_mc
		 * 
		 * @param	botoes					"true" para aparecerem os botoes, "false" para não aparecerem
		 * 
		 * @param	carrinho				"true" para aparecerem o carrinho_mc e o trilho_mc, "false" para não aparecerem
		 * 
		 * 
		 * @langversion ActionScript 3.0
		 * @playerversion Flash 9.0
		 */
		
		public function ScrollHorizontalFB (mascara:Sprite, container:Sprite, movimento:Number = 0, redimensionamento:Boolean = false, delay:Number = .1, botoes:Boolean = true, carrinho:Boolean = true):void {
			_mascara = mascara;
			_container = container;
			
			//_movimento no fim da função
			_delay = delay;
			_redimensionamento = redimensionamento;
			
			pontoMaximo = _mascara.x;
			pontoMinimo = _mascara.x + _mascara.width - _container.width;
			
			_container.mask = _mascara;
			scroll = new mcScrollHorizontal();
			
			if (!botoes) {
				scroll.esquerda_mc.visible = false;
				scroll.direita_mc.visible = false;
				scroll.trilho_mc.width = _mascara.width;
				scroll.trilho_mc.x = 0;
				scroll.carrinho_mc.x = 0;
			} else {
				scroll.trilho_mc.width = mascara.width - (scroll.esquerda_mc.width + 4) - (scroll.direita_mc.width + 4);
			}
			
			if (!carrinho) {
				scroll.carrinho_mc.visible = false;
				scroll.trilho_mc.visible = false;
			}
			
			scroll.x = mascara.x;
			scroll.y = mascara.y+mascara.height+4;
			scroll.direita_mc.x = mascara.width - scroll.direita_mc.width;
			
			if (_redimensionamento) {
				trace("redimensionou o carrinho horizontal");
				scroll.carrinho_mc.width = _mascara.width / _container.width * scroll.trilho_mc.width;
				trace(scroll.carrinho_mc.width );
			}
			limiteArraste = new Rectangle(scroll.carrinho_mc.x, scroll.carrinho_mc.y, scroll.trilho_mc.width-scroll.carrinho_mc.width, 0)
			
			configuraAcoes();
			
			_movimento = (movimento == 0)? _mascara.width / _container.width * scroll.trilho_mc.width : movimento;
			
			destinoContainer = _mascara.x;
			destinoCarrinho = scroll.trilho_mc.x;
			
			addChild(scroll);
		}
		
		private function configuraAcoes ():void {
			scroll.direita_mc.gotoAndStop(1);
			scroll.esquerda_mc.gotoAndStop(1);
			scroll.carrinho_mc.gotoAndStop(1);
			
			scroll.direita_mc.buttonMode = true;
			scroll.esquerda_mc.buttonMode = true;
			scroll.carrinho_mc.buttonMode = true;
			
			scroll.direita_mc.addEventListener(MouseEvent.MOUSE_OVER, over);
			scroll.esquerda_mc.addEventListener(MouseEvent.MOUSE_OVER, over);
			scroll.carrinho_mc.addEventListener(MouseEvent.MOUSE_OVER, over);
			
			scroll.direita_mc.addEventListener(MouseEvent.MOUSE_OUT, out);
			scroll.esquerda_mc.addEventListener(MouseEvent.MOUSE_OUT, out);
			scroll.carrinho_mc.addEventListener(MouseEvent.MOUSE_OUT, out);
			
			
			//direita
			scroll.direita_mc.addEventListener(MouseEvent.MOUSE_DOWN, function ():void {
				vaiPraDireita ();
				intervaloBotoes = setInterval(vaiPraDireita, 300);
				_container["root"].addEventListener(MouseEvent.MOUSE_UP, function (evt:MouseEvent):void {
					clearInterval(intervaloBotoes);
				});
			});
			
			//esquerda
			scroll.esquerda_mc.addEventListener(MouseEvent.MOUSE_DOWN, function ():void {
				vaiPraEsquerda ();
				intervaloBotoes = setInterval(vaiPraEsquerda, 300);
				_container["root"].addEventListener(MouseEvent.MOUSE_UP, function (evt:MouseEvent):void {
					clearInterval(intervaloBotoes);
				});
			});
			
			scroll.carrinho_mc.addEventListener(MouseEvent.MOUSE_DOWN, function (evt:MouseEvent):void {
				scroll.carrinho_mc.startDrag(false, limiteArraste);
				_container["root"].addEventListener(MouseEvent.MOUSE_UP, function (evt:MouseEvent):void { 
					destinoCarrinho = scroll.carrinho_mc.x;
					scroll.carrinho_mc.stopDrag();
					_container["root"].removeEventListener(Event.ENTER_FRAME, atualizaCarrinhoArrastando);
				} );
				_container["root"].addEventListener(Event.ENTER_FRAME, atualizaCarrinhoArrastando);
			});			
		}
		
		private function vaiPraDireita ():void {
			if (destinoCarrinho + _movimento < scroll.trilho_mc.x + scroll.trilho_mc.width-scroll.carrinho_mc.width-.1) {
				destinoCarrinho = Math.floor(destinoCarrinho + _movimento);
				trace("destinoCarrinho" + destinoCarrinho);
			} else {
				destinoCarrinho = scroll.trilho_mc.x+scroll.trilho_mc.width-scroll.carrinho_mc.width-.1;
			}
			atualizaCarrinho();
			
			TweenLite.to(scroll.carrinho_mc, _delay, { x:destinoCarrinho, onUpdate:botaoPraBaixo } );
		}
		private function vaiPraEsquerda ():void {
			if (destinoCarrinho - _movimento > scroll.trilho_mc.x) {
				destinoCarrinho = Math.floor(destinoCarrinho - _movimento);
			} else {
				destinoCarrinho = scroll.trilho_mc.x;
			}
			atualizaCarrinho();
			
			TweenLite.to(scroll.carrinho_mc, _delay, { x:destinoCarrinho, onUpdate:botaoPraBaixo } );
		}
		
		
		private function botaoPraBaixo (evt:Event = null):void {
			atualizaCarrinho();
		}
		
		private function atualizaCarrinho(evt:Event = null):void {
			var fator:Number = (scroll.carrinho_mc.x - scroll.trilho_mc.x) / (scroll.trilho_mc.width - scroll.carrinho_mc.width);
			destinoContainer = pontoMaximo - (pontoMaximo - pontoMinimo) * fator;
			_container.x = destinoContainer;
		}
		
		private function atualizaCarrinhoArrastando(evt:Event = null):void {
			var fator:Number = (scroll.carrinho_mc.x - scroll.trilho_mc.x) / (scroll.trilho_mc.width - scroll.carrinho_mc.width);
			destinoContainer = pontoMaximo - (pontoMaximo - pontoMinimo) * fator;
			TweenLite.to(_container, _delay, { x:destinoContainer } );
		}
		
		private function over (evt:MouseEvent):void {
			evt.currentTarget.gotoAndStop(2);
		}
		private function out (evt:MouseEvent):void {
			evt.currentTarget.gotoAndStop(1);
		}
		
		/**
		 * [read-only] No caso de mudanças nas dimensões do container chamar essa função.
		 * 
		 * @langversion ActionScript 3.0
		 * @playerversion Flash 9.0
		 
		public function recarrega():void {
			
			pontoMaximo = _mascara.x;
			pontoMinimo = _mascara.x + _mascara.width - _container.width;
			
			scroll.direita_mc.x = _mascara.width - scroll.direita_mc.width;
			
			if (_redimensionamento) {
				scroll.carrinho_mc.width = _mascara.width / _container.width * scroll.trilho_mc.width;
			}
			
			
			destinoContainer = _mascara.x;
			destinoCarrinho = scroll.trilho_mc.x;
			scroll.carrinho_mc.x = scroll.trilho_mc.x;
			limiteArraste = new Rectangle(scroll.carrinho_mc.x, scroll.carrinho_mc.y, scroll.trilho_mc.width-scroll.carrinho_mc.width, 0)
			configuraAcoes();
			atualizaCarrinhoArrastando();
		}*/
	}
}