package 
{
	import appkit.responders.NResponder;
	import com.greensock.plugins.TintPlugin;
	import com.greensock.plugins.TweenPlugin;
	import com.greensock.TweenMax;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import org.flashdevelop.utils.FlashConnect;
	
	
	/**
	 * ...
	 * @author Iargo A Rocha
	 */
	public class Cores extends MovieClip {
		private var tela:mcCores = new mcCores();
		private var cores:Vector.<Cor> = new Vector.<Cor>;
		private var colecoes:Vector.<Colecao> = new Vector.<Colecao>;
		private var mao:Mao = new Mao();
		private var combo:mcCombo = new mcCombo();
		
		private var colecoes_loader:URLLoader = new URLLoader();
		private var dados:XML;
		
		
		public function Cores():void {
			TweenPlugin.activate([TintPlugin]);
			
			colecoes_loader.addEventListener(Event.COMPLETE, retemCores);
			
			var flashVars:Object = LoaderInfo(this.root.loaderInfo).parameters;
            var xmlACarregar:String;
			xmlACarregar = flashVars['xml']
			if (xmlACarregar == null) {
				xmlACarregar = 'xml/cores.xml';
			}
			
			colecoes_loader.load(new URLRequest(xmlACarregar));
			
			addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function retemCores(e:Event):void {
			dados = new XML(e.target.data);
			
			for each (var colecao_xml:XML in dados.colecao) {
				var nome_colecao:String = colecao_xml.nome;
				var cores_da_colecao:Vector.<Cor> = new Vector.<Cor>;
				for each (var cor_xml:XML in colecao_xml.cores.cor) {
					var cor:Cor = new Cor(cor_xml.hexa, cor_xml.nome);
					cores_da_colecao.push(new Cor(cor_xml.hexa, cor_xml.nome));
					
				}
				colecoes.push(new Colecao(cores_da_colecao, nome_colecao));
			}
			NResponder.add('carrega_colecao', carrega_colecao);
			geraCombo();
			addChild(combo);
			carrega_colecao(colecoes[0]);
		}
		
		private function geraCombo():void {
			
			var posx:Number = 0;
			var posy:Number = 10;
			
			for (var i:int = 0; i < colecoes.length; i++) {
				var item:mcComboItem = new mcComboItem();
				item.colecao = colecoes[i];
				item.nome_txt.text = item.colecao.nome;
				item.x = posx;
				item.y = posy;
				posy += 33;
				if ((i + 1) % 5 == 0) {
					posx += 130;
					posy = 10;
				}
				
				
				item.addEventListener(MouseEvent.CLICK, function (e:MouseEvent):void {
					NResponder.dispatch('carrega_colecao', [e.currentTarget.colecao]);
				});
				
				combo.colecoes_mc.addChild(item);
				item.buttonMode = true;
			}
			
			
			combo.tampa_mc.addEventListener(MouseEvent.CLICK, function ():void {
				fechar_combo();
			});
			combo.botao_mc.buttonMode = true;
			combo.botao_mc.addEventListener(MouseEvent.CLICK, function ():void {
				combo.tampa_mc.visible = true;
				TweenMax.to(combo.mask_mc, .5, {width:combo.colecoes_mc.width, height:combo.colecoes_mc.height+10})
			});
		}
		private function fechar_combo():void {
			combo.tampa_mc.visible = false;
			TweenMax.to(combo.mask_mc, .5, {width:1, height:1})
		}
		private function init(e:Event = null):void {
			FlashConnect.trace("Mao init()");
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			addChild(tela);
		}
		
		private function carrega_colecao(colecao:Colecao):void {
			fechar_combo();
			
			combo.colecao_txt.text = colecao.nome+":";
			
			var filhos:int = tela.cores_mc.numChildren;
			for (var j:int = 0; j < filhos ; j++) {
				tela.cores_mc.removeChildAt(0);
			}
			filhos = tela.paginacao_mc.numChildren;
			for (j = 0; j < filhos ; j++) {
				tela.paginacao_mc.removeChildAt(0);
			}
			
			
			cores = new Vector.<Cor>;
			for (var k:int = 0; k < colecao.cores.length; k++) {
				cores.push(colecao.cores[k]);
			}
			
			
			var posx:Number = 11;
			var posy:Number = 0;
			tela.cores_mc.y = 251;
			var i:int;
			var paginacao:Array = new Array();
			for (i = 0; i < cores.length; i++) {
				cores[i].x = posx;
				cores[i].y = posy;
				
				posx += 30;
				if ((i + 1) % 4 == 0) {
					posx = 11;
					posy += 30;
				}
				if (i% 16 == 0) {
					var paginador:mcPaginacao = new mcPaginacao();
					paginador.pag = (i - (i % 16)) / 16;
					paginador.num_txt.text = paginador.pag + 1;
					paginador.x = paginador.pag * 20;
					trace (paginador.pag);
					paginacao.push(paginador);
					paginador.buttonMode = true;
					paginador.addEventListener(MouseEvent.CLICK, function (e:MouseEvent):void {
						for (var m:int = 0; m < paginacao.length; m++) 	{
							paginacao[m].alpha = 1;
						}
						TweenMax.to(tela.cores_mc, .3, { y:251 - (120 * e.currentTarget.pag) } );
						 
						e.currentTarget.alpha = .5;
					});
				}
				tela.cores_mc.addChild(cores[i]);
			}
			for (var l:int = 0; l < paginacao.length; l++) {
				tela.paginacao_mc.addChild(paginacao[l]);
			}
			tela.paginacao_mc.x = 120 - (paginacao.length * 20);
			if (paginacao.length < 2) {
				tela.paginacao_mc.visible = false;
			} else {
				tela.paginacao_mc.visible = true;
				paginacao[0].alpha = .5;
			}
		}
	}
}